#include "Gra.ch"
#include "Xbp.ch"
#include "Common.ch"
#include "Appevent.ch"
#include "Font.ch"
#include "dll.ch"

#define SmallBoard              252
#define KeyNavigate             252
#define NumPadOnly              252

PROCEDURE AppSys
RETURN

PROCEDURE Main(cPara)
LOCAL nEvent, oXbp, mp1, mp2
LOCAL oDlg

   oDlg := ADlg():New()
   oDlg:taskList := .T.
   oDlg:title := "3 Parts"
   oDlg:Create()
   CenterControl(oDlg)
   oDlg:show()

   nEvent := xbe_None
   WHILE nEvent != xbeP_Close
      nEvent := AppEvent ( @mp1, @mp2, @oXbp )
      oXbp:HandleEvent ( nEvent, mp1, mp2 )
      IF nEvent == xbeP_Quit
         QUIT   // AppQuit()
      ENDIF
   ENDDO

RETURN

******************************************************************************

STATIC FUNCTION PopAbsPos( oMainDlg, lTopDown )
LOCAL aPos := { 0, 0 }
LOCAL aDlg := oMainDlg:currentpos()
LOCAL aAbs := GetCursorPos( lTopDown )

   aPos[ 1 ] := aAbs[ 1 ] - aDlg[ 1 ]
   aPos[ 2 ] := aAbs[ 2 ] - aDlg[ 2 ]

RETURN aPos

STATIC FUNCTION GetCursorPos( lTopDown )
LOCAL sPoint := REPLICATE( CHR( 0 ), 8 )
LOCAL nX     := 0
LOCAL nY     := 0

   DEFAULT lTopDown TO .T.

   DllCall( "USER32.DLL", DLL_STDCALL, "GetCursorPos", @sPoint )

   nX := BIN2L( SUBSTR( sPoint, 1, 4 ) )
   nY := BIN2L( SUBSTR( sPoint, 5, 4 ) )

   IF lTopDown
      nY := ( - 1 * nY ) + APPDESKTOP() :CURRENTSIZE() [2] - 1    // Top-Down
   ENDIF

RETURN ( { nX, nY } )

******************************************************************************

CLASS AForm FROM XbpDialog
EXPORTED:
   VAR oStat1
   VAR oStat2
   VAR oStat3

   VAR aStart

   METHOD init
   METHOD create
ENDCLASS

METHOD AForm:init( oParent, oOwner, aPos, aSize, aPP, lVisible )

   DEFAULT oParent  TO AppDesktop(), ;
           aPos     TO {136,408}, ;
           lVisible TO .F.

   DEFAULT aPP TO {}
   AAdd ( aPP, { XBP_PP_COMPOUNDNAME, "8.Arial" } )

   IF Empty(aSize) == .T.
      IF IsMemberVar(self,"ClientSize") == .T.
         aSize := {0,0}
      ELSE
         aSize := {774,299}
      ENDIF
   ENDIF

   ::XbpDialog:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   IF aSize[1] == 0 .AND. aSize[2] == 0
      ::XbpDialog:ClientSize := {758,265}
   ENDIF

   ::oStat1 := XbpStatic():new( ::drawingArea, , {0,4}, {252,260}, { { XBP_PP_BGCLR, GRA_CLR_GREEN } } )
   ::oStat1:caption := "Text"
   ::oStat1:clipSiblings := .T.
   ::oStat1:options := XBPSTATIC_TEXT_VCENTER+XBPSTATIC_TEXT_CENTER

   ::oStat2 := XbpStatic():new( ::drawingArea, , {252,4}, {252,260}, { { XBP_PP_BGCLR, GRA_CLR_YELLOW } } )
   ::oStat2:caption := "Text"
   ::oStat2:clipSiblings := .T.
   ::oStat2:options := XBPSTATIC_TEXT_VCENTER+XBPSTATIC_TEXT_CENTER

   ::oStat3 := XbpStatic():new( ::drawingArea, , {504,4}, {252,260}, { { XBP_PP_BGCLR, GRA_CLR_RED } } )
   ::oStat3:caption := "Text"
   ::oStat3:clipSiblings := .T.
   ::oStat3:options := XBPSTATIC_TEXT_VCENTER+XBPSTATIC_TEXT_CENTER

RETURN self

METHOD AForm:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::XbpDialog:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::oStat1:create()
   ::oStat2:create()
   ::oStat3:create()

   ::aStart := ACLONE( ::DrawingArea:CurrentSize() )

RETURN self

******************************************************************************

CLASS ADlg FROM AForm
EXPORTED:
   METHOD init
   METHOD create
   METHOD PopUpTab()
   METHOD SetLayout()

   VAR lLayoutLeft
   VAR lLayoutMid
   VAR lLayoutRight

ENDCLASS

METHOD ADlg:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::AForm:init( oParent, oOwner, aPos, aSize, aPP, lVisible )

   ::lLayoutLeft  := .T.
   ::lLayoutMid   := .T.
   ::lLayoutRight := .T.

RETURN self

METHOD ADlg:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::AForm:create( oParent, oOwner, aPos, aSize, aPP, lVisible )

   ::oStat1:rbDown := { | aPos, uNIL, oSelf | ::PopUpTab(oSelf) }
   ::oStat2:rbDown := { | aPos, uNIL, oSelf | ::PopUpTab(oSelf) }
   ::oStat3:rbDown := { | aPos, uNIL, oSelf | ::PopUpTab(oSelf) }

RETURN self

METHOD ADlg:PopUpTab( oSelf )

LOCAL oMenu := XBPMENU() :new( oSelf )

   oMenu:create()

   oMenu:AddItem( { "~Full  Layout", { || ::SetLayout(1) } } )
   oMenu:AddItem( { "~Small Layout", { || ::SetLayout(2) } } )
   oMenu:AddItem( { "~Small+Cursor", { || ::SetLayout(3) } } )
   oMenu:AddItem( { "~Numpad  Only", { || ::SetLayout(4) } } )

   oMenu:PopUp( oSelf:SetParent(), PopAbsPos( oSelf:SetParent():SetParent() ), 2, ;
                XBPMENU_PU_DEFAULT + XBPMENU_PU_MOUSE_RBDOWN )
RETURN

METHOD ADlg:SetLayout(nLayout)
LOCAL aSize := ACLONE( ::aStart )

   ::lLayoutLeft  := .T.
   ::lLayoutMid   := .T.
   ::lLayoutRight := .T.

   DO CASE
      CASE nLayout = 1

      CASE nLayout = 2
         ::lLayoutMid := .F.
         ::lLayoutRight := .F.

      CASE nLayout = 3
         ::lLayoutRight := .F.

      CASE nLayout = 4
         ::lLayoutLeft := .F.
         ::lLayoutMid := .F.
   ENDCASE

   DO CASE

      CASE ::lLayoutLeft = .T. .AND. ::lLayoutMid = .T. .AND. ::lLayoutRight = .T.
         ::oStat1:enable()   ; ::oStat1:toFront()
         ::oStat2:enable()   ; ::oStat2:toFront()
         ::oStat3:enable()   ; ::oStat3:toFront()

         ::oStat1:SetPos({0,0})
         ::oStat2:SetPos({SmallBoard,0})
         ::oStat3:SetPos({SmallBoard + KeyNavigate,0})

      CASE ::lLayoutLeft = .T. .AND. ::lLayoutMid = .F. .AND. ::lLayoutRight = .F.
         ::oStat1:enable()   ; ::oStat1:toFront()
         ::oStat2:disable()  ; ::oStat2:toBack()
         ::oStat3:disable()  ; ::oStat3:toBack()

         ::oStat1:SetPos({0,0})

         aSize[1] := SmallBoard

      CASE ::lLayoutLeft = .T. .AND. ::lLayoutMid = .T. .AND. ::lLayoutRight = .F.
         ::oStat1:enable()   ; ::oStat1:toFront()
         ::oStat2:enable()   ; ::oStat2:toFront()
         ::oStat3:disable()  ; ::oStat3:toBack()

         ::oStat1:SetPos({0,0})
         ::oStat2:SetPos({SmallBoard,0})

         aSize[1] := SmallBoard + KeyNavigate

      CASE ::lLayoutLeft = .F. .AND. ::lLayoutMid = .F. .AND. ::lLayoutRight = .T.
         ::oStat1:disable()  ; ::oStat1:toBack()
         ::oStat2:disable()  ; ::oStat2:toBack()
         ::oStat3:enable()   ; ::oStat3:toFront()

         ::oStat3:SetPos({0,0})

         aSize[1] := NumPadOnly
   ENDCASE

   ::ClientSize := aSize

RETURN


*
*
*